#const WXC_OWN_VIDEO = true

Sub init()
    m.Video = m.top.findNode("Video") 'wxc? why have to moved here?
	indexloaded(Invalid)

    m.InputTask=createObject("roSgNode","inputTask")
    m.InputTask.observefield("inputData","handleInputEvent")
    m.InputTask.control="RUN"

    m.Video = m.top.findNode("Video")
	m.Video.SetFocus(true)
End Sub

sub indexloaded(msg as Object)
	m.mediaIndex = {} '6c9 is white. 2c4
#if WXC_OWN_VIDEO
	m.mediaIndex["Gym"] = {url: "http://10.15.27.65:8080/static/Gym8s.mp4"}
	m.mediaIndex["Party"] = {url: "http://10.15.27.65:8080/static/Party.mp4"}
#else
	m.mediaIndex["6c9d0951d6d74229afe4adf972b278dd"] = {url: "http://roku.content.video.llnw.net/smedia/59021fabe3b645968e382ac726cd6c7b/An/Ad7-vxssRzyBjjdbdLdikctclTqxwEGsVWZGpiKp4/roku_ep_115_segment_5_paula_nw_050515.mp4"}
	m.mediaIndex["2c4e8ea1ad2f4a8d9d244f5dd4cc47b6"] = {url: "http://roku.content.video.llnw.net/smedia/59021fabe3b645968e382ac726cd6c7b/-q/2sQpF_wSsO8JsXyS4K25pVQY48OrAP6d55P11SxWI/ep-123-seq-4-nick-alt_081215.mp4"}
#end if
    ? "wxc m.mediaIndex= "; FormatJson(m.mediaIndex)
	deeplink = m.global.deeplink
	if deeplink = Invalid
		? "give deeplink a default so that it works when launched without curl"
#if WXC_OWN_VIDEO
        id = "Gym"
#else
        id = "6c9d0951d6d74229afe4adf972b278dd"
#end if
		deeplink = { id: id, type: "movie" }
	end if
    handleDeepLink(deeplink)
end sub

Function handleDeepLink(deeplink as object)
  if validateDeepLink(deeplink)
	url = m.mediaIndex[deeplink.id].url
    playVideo(url)
	print "wxc url="m.mediaIndex[deeplink.id].url  ", deeplink.id="deeplink.id
  else
    print "deeplink not validated, have to use curl to launch"
  end if
end Function

sub handleInputEvent(msg)
    ? "in handleInputEvent()"
    if type(msg) = "roSGNodeEvent" and msg.getField() = "inputData"
        deeplink = msg.getData()
        if deeplink <> invalid
            handleDeepLink(deeplink)
        end if
    end if
end sub

function validateDeepLink(deeplink as Object) as Boolean
  mediatypes={movie:"movie",episode:"episode",season:"season",series:"series"}
  if deeplink <> Invalid
      ? "mediaType = "; deeplink.type
      ? "contentId = "; deeplink.id
      ? "content= "; m.mediaIndex[deeplink.id]
      if deeplink.type <> invalid then
        if mediatypes[deeplink.type]<> invalid
          if m.mediaIndex[deeplink.id] <> invalid
            if m.mediaIndex[deeplink.id].url <> invalid
              return true
            else
                print "invalid deep link url"
            end if
          else
            print "bad deep link contentId"
          end if
        else
          print "unknown media type"
        end if
      else
        print "deeplink.type string is invalid"
      end if
  end if
  return false
end function

Sub playVideo(url = invalid)
    ? "url= "; url
    if type(url) = "roSGNodeEvent"   ' passed from observe callback'
		stop
    else
		VideoContent = createObject("roSGNode", "ContentNode")
        videoContent.url = url
    end if

    videoContent.streamFormat = "mp4"
    keepPlaying = false

    m.Video.content = videoContent
    m.Video.visible = "true"
    m.Video.control = "play"
End Sub


